/* CustomMessageDialog.c generated by valac 0.56.3, the Vala compiler
 * generated from CustomMessageDialog.vala, do not modify */

/*
 * CustomMessageDialog.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>

#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_CUSTOM_MESSAGE_DIALOG (custom_message_dialog_get_type ())
#define CUSTOM_MESSAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CUSTOM_MESSAGE_DIALOG, CustomMessageDialog))
#define CUSTOM_MESSAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CUSTOM_MESSAGE_DIALOG, CustomMessageDialogClass))
#define IS_CUSTOM_MESSAGE_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CUSTOM_MESSAGE_DIALOG))
#define IS_CUSTOM_MESSAGE_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CUSTOM_MESSAGE_DIALOG))
#define CUSTOM_MESSAGE_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CUSTOM_MESSAGE_DIALOG, CustomMessageDialogClass))

typedef struct _CustomMessageDialog CustomMessageDialog;
typedef struct _CustomMessageDialogClass CustomMessageDialogClass;
typedef struct _CustomMessageDialogPrivate CustomMessageDialogPrivate;
enum  {
	CUSTOM_MESSAGE_DIALOG_0_PROPERTY,
	CUSTOM_MESSAGE_DIALOG_NUM_PROPERTIES
};
static GParamSpec* custom_message_dialog_properties[CUSTOM_MESSAGE_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _CustomMessageDialog {
	GtkDialog parent_instance;
	CustomMessageDialogPrivate * priv;
};

struct _CustomMessageDialogClass {
	GtkDialogClass parent_class;
};

struct _CustomMessageDialogPrivate {
	GtkBox* vbox_main;
	GtkLabel* lbl_msg;
	GtkScrolledWindow* sw_msg;
	GtkButton* btn_ok;
	GtkButton* btn_cancel;
	GtkButton* btn_yes;
	GtkButton* btn_no;
	gchar* msg_title;
	gchar* msg_body;
	GtkMessageType msg_type;
	GtkButtonsType buttons_type;
};

static gint CustomMessageDialog_private_offset;
static gpointer custom_message_dialog_parent_class = NULL;

VALA_EXTERN GType custom_message_dialog_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (CustomMessageDialog, g_object_unref)
VALA_EXTERN CustomMessageDialog* custom_message_dialog_new (const gchar* _msg_title,
                                                const gchar* _msg_body,
                                                GtkMessageType _msg_type,
                                                GtkWindow* parent,
                                                GtkButtonsType _buttons_type);
VALA_EXTERN CustomMessageDialog* custom_message_dialog_construct (GType object_type,
                                                      const gchar* _msg_title,
                                                      const gchar* _msg_body,
                                                      GtkMessageType _msg_type,
                                                      GtkWindow* parent,
                                                      GtkButtonsType _buttons_type);
VALA_EXTERN void custom_message_dialog_init_window (CustomMessageDialog* self);
VALA_EXTERN GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
VALA_EXTERN gchar* tee_jee_misc_escape_html (const gchar* html);
static void custom_message_dialog_finalize (GObject * obj);
static GType custom_message_dialog_get_type_once (void);

static inline gpointer
custom_message_dialog_get_instance_private (CustomMessageDialog* self)
{
	return G_STRUCT_MEMBER_P (self, CustomMessageDialog_private_offset);
}

CustomMessageDialog*
custom_message_dialog_construct (GType object_type,
                                 const gchar* _msg_title,
                                 const gchar* _msg_body,
                                 GtkMessageType _msg_type,
                                 GtkWindow* parent,
                                 GtkButtonsType _buttons_type)
{
	CustomMessageDialog * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkLabel* _tmp2_;
	GtkScrolledWindow* _tmp3_;
	GtkScrolledWindow* _tmp4_;
	GtkScrolledWindow* _tmp5_;
	GtkLabel* _tmp6_;
#line 51 "Utility/Gtk/CustomMessageDialog.vala"
	g_return_val_if_fail (_msg_title != NULL, NULL);
#line 51 "Utility/Gtk/CustomMessageDialog.vala"
	g_return_val_if_fail (_msg_body != NULL, NULL);
#line 51 "Utility/Gtk/CustomMessageDialog.vala"
	self = (CustomMessageDialog*) g_object_new (object_type, NULL);
#line 53 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, parent);
#line 54 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
#line 56 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp0_ = g_strdup (_msg_title);
#line 56 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (self->priv->msg_title);
#line 56 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->msg_title = _tmp0_;
#line 57 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp1_ = g_strdup (_msg_body);
#line 57 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (self->priv->msg_body);
#line 57 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->msg_body = _tmp1_;
#line 58 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->msg_type = _msg_type;
#line 59 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->buttons_type = _buttons_type;
#line 61 "Utility/Gtk/CustomMessageDialog.vala"
	custom_message_dialog_init_window (self);
#line 63 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp2_ = self->priv->lbl_msg;
#line 63 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set ((GtkWidget*) _tmp2_, "expand", TRUE, NULL);
#line 64 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp3_ = self->priv->sw_msg;
#line 64 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set ((GtkWidget*) _tmp3_, "expand", TRUE, NULL);
#line 65 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp4_ = self->priv->sw_msg;
#line 65 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set (_tmp4_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 67 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp5_ = self->priv->sw_msg;
#line 67 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp5_, 500, 150);
#line 69 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 71 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp6_ = self->priv->lbl_msg;
#line 71 "Utility/Gtk/CustomMessageDialog.vala"
	if (gtk_widget_get_allocated_height ((GtkWidget*) _tmp6_) > 400) {
#line 186 "CustomMessageDialog.c"
		GtkScrolledWindow* _tmp7_;
		GtkScrolledWindow* _tmp8_;
#line 72 "Utility/Gtk/CustomMessageDialog.vala"
		_tmp7_ = self->priv->sw_msg;
#line 72 "Utility/Gtk/CustomMessageDialog.vala"
		g_object_set (_tmp7_, "vscrollbar-policy", GTK_POLICY_AUTOMATIC, NULL);
#line 73 "Utility/Gtk/CustomMessageDialog.vala"
		_tmp8_ = self->priv->sw_msg;
#line 73 "Utility/Gtk/CustomMessageDialog.vala"
		gtk_widget_set_size_request ((GtkWidget*) _tmp8_, 500, 400);
#line 197 "CustomMessageDialog.c"
	}
#line 51 "Utility/Gtk/CustomMessageDialog.vala"
	return self;
#line 201 "CustomMessageDialog.c"
}

CustomMessageDialog*
custom_message_dialog_new (const gchar* _msg_title,
                           const gchar* _msg_body,
                           GtkMessageType _msg_type,
                           GtkWindow* parent,
                           GtkButtonsType _buttons_type)
{
#line 51 "Utility/Gtk/CustomMessageDialog.vala"
	return custom_message_dialog_construct (TYPE_CUSTOM_MESSAGE_DIALOG, _msg_title, _msg_body, _msg_type, parent, _buttons_type);
#line 213 "CustomMessageDialog.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 88 "Utility/Gtk/CustomMessageDialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 221 "CustomMessageDialog.c"
}

void
custom_message_dialog_init_window (CustomMessageDialog* self)
{
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
	GtkBox* _tmp2_;
	GtkBox* _tmp3_;
	GtkBox* _tmp4_;
	GtkBox* hbox_contents = NULL;
	GtkBox* _tmp5_;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkBox* _tmp8_;
	gchar* icon_name = NULL;
	gchar* _tmp9_;
	GtkImage* img = NULL;
	const gchar* _tmp15_;
	GtkImage* _tmp16_;
	GtkBox* _tmp17_;
	GtkImage* _tmp18_;
	gchar* text = NULL;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	GtkLabel* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkLabel* _tmp29_;
	GtkLabel* _tmp30_;
	GtkLabel* _tmp31_;
	GtkLabel* _tmp32_;
	GtkScrolledWindow* _tmp33_;
	GtkScrolledWindow* _tmp34_;
	GtkLabel* _tmp35_;
	GtkScrolledWindow* _tmp36_;
	GtkScrolledWindow* _tmp37_;
	GtkBox* _tmp38_;
	GtkScrolledWindow* _tmp39_;
#line 77 "Utility/Gtk/CustomMessageDialog.vala"
	g_return_if_fail (self != NULL);
#line 79 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_title ((GtkWindow*) self, "");
#line 80 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set ((GtkWindow*) self, "window-position", GTK_WIN_POS_CENTER_ON_PARENT, NULL);
#line 81 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp0_ = icon_manager_lookup ("timeshift", 16, FALSE, FALSE, 1);
#line 81 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp1_ = _tmp0_;
#line 81 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_icon ((GtkWindow*) self, _tmp1_);
#line 81 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (_tmp1_);
#line 82 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 83 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_deletable ((GtkWindow*) self, FALSE);
#line 84 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_skip_taskbar_hint ((GtkWindow*) self, TRUE);
#line 85 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_window_set_skip_pager_hint ((GtkWindow*) self, TRUE);
#line 88 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp2_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 88 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_box_get_type ()) ? ((GtkBox*) _tmp2_) : NULL);
#line 88 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 88 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->vbox_main = _tmp3_;
#line 89 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp4_ = self->priv->vbox_main;
#line 89 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set ((GtkWidget*) _tmp4_, "margin", 6, NULL);
#line 92 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp5_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 92 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_ref_sink (_tmp5_);
#line 92 "Utility/Gtk/CustomMessageDialog.vala"
	hbox_contents = _tmp5_;
#line 93 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp6_ = hbox_contents;
#line 93 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set ((GtkWidget*) _tmp6_, "margin", 6, NULL);
#line 94 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp7_ = self->priv->vbox_main;
#line 94 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp8_ = hbox_contents;
#line 94 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) _tmp8_);
#line 96 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp9_ = g_strdup ("dialog-info");
#line 96 "Utility/Gtk/CustomMessageDialog.vala"
	icon_name = _tmp9_;
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
	switch (self->priv->msg_type) {
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_MESSAGE_INFO:
#line 324 "CustomMessageDialog.c"
		{
			gchar* _tmp10_;
#line 100 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp10_ = g_strdup ("dialog-info");
#line 100 "Utility/Gtk/CustomMessageDialog.vala"
			_g_free0 (icon_name);
#line 100 "Utility/Gtk/CustomMessageDialog.vala"
			icon_name = _tmp10_;
#line 101 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 335 "CustomMessageDialog.c"
		}
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_MESSAGE_WARNING:
#line 339 "CustomMessageDialog.c"
		{
			gchar* _tmp11_;
#line 103 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp11_ = g_strdup ("dialog-warning");
#line 103 "Utility/Gtk/CustomMessageDialog.vala"
			_g_free0 (icon_name);
#line 103 "Utility/Gtk/CustomMessageDialog.vala"
			icon_name = _tmp11_;
#line 104 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 350 "CustomMessageDialog.c"
		}
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_MESSAGE_QUESTION:
#line 354 "CustomMessageDialog.c"
		{
			gchar* _tmp12_;
#line 106 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp12_ = g_strdup ("dialog-question");
#line 106 "Utility/Gtk/CustomMessageDialog.vala"
			_g_free0 (icon_name);
#line 106 "Utility/Gtk/CustomMessageDialog.vala"
			icon_name = _tmp12_;
#line 107 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 365 "CustomMessageDialog.c"
		}
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_MESSAGE_ERROR:
#line 369 "CustomMessageDialog.c"
		{
			gchar* _tmp13_;
#line 109 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp13_ = g_strdup ("dialog-error");
#line 109 "Utility/Gtk/CustomMessageDialog.vala"
			_g_free0 (icon_name);
#line 109 "Utility/Gtk/CustomMessageDialog.vala"
			icon_name = _tmp13_;
#line 110 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 380 "CustomMessageDialog.c"
		}
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_MESSAGE_OTHER:
#line 384 "CustomMessageDialog.c"
		{
			gchar* _tmp14_;
#line 112 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp14_ = g_strdup ("dialog-info");
#line 112 "Utility/Gtk/CustomMessageDialog.vala"
			_g_free0 (icon_name);
#line 112 "Utility/Gtk/CustomMessageDialog.vala"
			icon_name = _tmp14_;
#line 113 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 395 "CustomMessageDialog.c"
		}
		default:
#line 98 "Utility/Gtk/CustomMessageDialog.vala"
		break;
#line 400 "CustomMessageDialog.c"
	}
#line 118 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp15_ = icon_name;
#line 118 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp16_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp15_, (GtkIconSize) GTK_ICON_SIZE_DIALOG);
#line 118 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_ref_sink (_tmp16_);
#line 118 "Utility/Gtk/CustomMessageDialog.vala"
	img = _tmp16_;
#line 119 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp17_ = hbox_contents;
#line 119 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp18_ = img;
#line 119 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp17_, (GtkWidget*) _tmp18_);
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp19_ = self->priv->msg_title;
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp20_ = tee_jee_misc_escape_html (_tmp19_);
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp21_ = _tmp20_;
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp22_ = self->priv->msg_body;
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp23_ = g_strdup_printf ("<span weight=\"bold\" size=\"x-large\">%s</span>\n\n%s", _tmp21_, _tmp22_);
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp24_ = _tmp23_;
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (_tmp21_);
#line 123 "Utility/Gtk/CustomMessageDialog.vala"
	text = _tmp24_;
#line 126 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp25_ = text;
#line 126 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp26_ = (GtkLabel*) gtk_label_new (_tmp25_);
#line 126 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_ref_sink (_tmp26_);
#line 126 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->lbl_msg);
#line 126 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->lbl_msg = _tmp26_;
#line 127 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp27_ = self->priv->lbl_msg;
#line 127 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_label_set_xalign (_tmp27_, 0.0f);
#line 128 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp28_ = self->priv->lbl_msg;
#line 128 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_label_set_yalign (_tmp28_, 0.0f);
#line 129 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp29_ = self->priv->lbl_msg;
#line 129 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_label_set_max_width_chars (_tmp29_, 70);
#line 130 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp30_ = self->priv->lbl_msg;
#line 130 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set (_tmp30_, "wrap", TRUE, NULL);
#line 131 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp31_ = self->priv->lbl_msg;
#line 131 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set (_tmp31_, "wrap-mode", PANGO_WRAP_WORD_CHAR, NULL);
#line 132 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp32_ = self->priv->lbl_msg;
#line 132 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_label_set_use_markup (_tmp32_, TRUE);
#line 135 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp33_ = (GtkScrolledWindow*) gtk_scrolled_window_new (NULL, NULL);
#line 135 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_ref_sink (_tmp33_);
#line 135 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->sw_msg);
#line 135 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv->sw_msg = _tmp33_;
#line 137 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp34_ = self->priv->sw_msg;
#line 137 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp35_ = self->priv->lbl_msg;
#line 137 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp34_, (GtkWidget*) _tmp35_);
#line 138 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp36_ = self->priv->sw_msg;
#line 138 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set (_tmp36_, "hscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 139 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp37_ = self->priv->sw_msg;
#line 139 "Utility/Gtk/CustomMessageDialog.vala"
	g_object_set (_tmp37_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
#line 141 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp38_ = hbox_contents;
#line 141 "Utility/Gtk/CustomMessageDialog.vala"
	_tmp39_ = self->priv->sw_msg;
#line 141 "Utility/Gtk/CustomMessageDialog.vala"
	gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 145 "Utility/Gtk/CustomMessageDialog.vala"
	switch (self->priv->buttons_type) {
#line 145 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_BUTTONS_OK:
#line 498 "CustomMessageDialog.c"
		{
			GtkWidget* _tmp40_;
			GtkButton* _tmp41_;
			GtkButton* _tmp42_;
#line 147 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp40_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("OK"), (gint) GTK_RESPONSE_OK);
#line 147 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp41_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp40_, gtk_button_get_type (), GtkButton));
#line 147 "Utility/Gtk/CustomMessageDialog.vala"
			_g_object_unref0 (self->priv->btn_ok);
#line 147 "Utility/Gtk/CustomMessageDialog.vala"
			self->priv->btn_ok = _tmp41_;
#line 148 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp42_ = self->priv->btn_ok;
#line 148 "Utility/Gtk/CustomMessageDialog.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp42_);
#line 149 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 517 "CustomMessageDialog.c"
		}
#line 145 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_BUTTONS_OK_CANCEL:
#line 521 "CustomMessageDialog.c"
		{
			GtkWidget* _tmp43_;
			GtkButton* _tmp44_;
			GtkWidget* _tmp45_;
			GtkButton* _tmp46_;
			GtkButton* _tmp47_;
#line 151 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp43_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("OK"), (gint) GTK_RESPONSE_OK);
#line 151 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp44_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp43_, gtk_button_get_type (), GtkButton));
#line 151 "Utility/Gtk/CustomMessageDialog.vala"
			_g_object_unref0 (self->priv->btn_ok);
#line 151 "Utility/Gtk/CustomMessageDialog.vala"
			self->priv->btn_ok = _tmp44_;
#line 152 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp45_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Cancel"), (gint) GTK_RESPONSE_CANCEL);
#line 152 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp46_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_button_get_type (), GtkButton));
#line 152 "Utility/Gtk/CustomMessageDialog.vala"
			_g_object_unref0 (self->priv->btn_cancel);
#line 152 "Utility/Gtk/CustomMessageDialog.vala"
			self->priv->btn_cancel = _tmp46_;
#line 153 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp47_ = self->priv->btn_ok;
#line 153 "Utility/Gtk/CustomMessageDialog.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp47_);
#line 154 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 550 "CustomMessageDialog.c"
		}
#line 145 "Utility/Gtk/CustomMessageDialog.vala"
		case GTK_BUTTONS_YES_NO:
#line 554 "CustomMessageDialog.c"
		{
			GtkWidget* _tmp48_;
			GtkButton* _tmp49_;
			GtkWidget* _tmp50_;
			GtkButton* _tmp51_;
			GtkButton* _tmp52_;
#line 156 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp48_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("Yes"), (gint) GTK_RESPONSE_YES);
#line 156 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp49_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp48_, gtk_button_get_type (), GtkButton));
#line 156 "Utility/Gtk/CustomMessageDialog.vala"
			_g_object_unref0 (self->priv->btn_yes);
#line 156 "Utility/Gtk/CustomMessageDialog.vala"
			self->priv->btn_yes = _tmp49_;
#line 157 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp50_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("No"), (gint) GTK_RESPONSE_NO);
#line 157 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp51_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp50_, gtk_button_get_type (), GtkButton));
#line 157 "Utility/Gtk/CustomMessageDialog.vala"
			_g_object_unref0 (self->priv->btn_no);
#line 157 "Utility/Gtk/CustomMessageDialog.vala"
			self->priv->btn_no = _tmp51_;
#line 158 "Utility/Gtk/CustomMessageDialog.vala"
			_tmp52_ = self->priv->btn_yes;
#line 158 "Utility/Gtk/CustomMessageDialog.vala"
			gtk_widget_grab_focus ((GtkWidget*) _tmp52_);
#line 159 "Utility/Gtk/CustomMessageDialog.vala"
			break;
#line 583 "CustomMessageDialog.c"
		}
		default:
#line 145 "Utility/Gtk/CustomMessageDialog.vala"
		break;
#line 588 "CustomMessageDialog.c"
	}
#line 77 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (text);
#line 77 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (img);
#line 77 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (icon_name);
#line 77 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (hbox_contents);
#line 598 "CustomMessageDialog.c"
}

static void
custom_message_dialog_class_init (CustomMessageDialogClass * klass,
                                  gpointer klass_data)
{
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	custom_message_dialog_parent_class = g_type_class_peek_parent (klass);
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	g_type_class_adjust_private_offset (klass, &CustomMessageDialog_private_offset);
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	G_OBJECT_CLASS (klass)->finalize = custom_message_dialog_finalize;
#line 611 "CustomMessageDialog.c"
}

static void
custom_message_dialog_instance_init (CustomMessageDialog * self,
                                     gpointer klass)
{
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	self->priv = custom_message_dialog_get_instance_private (self);
#line 620 "CustomMessageDialog.c"
}

static void
custom_message_dialog_finalize (GObject * obj)
{
	CustomMessageDialog * self;
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CUSTOM_MESSAGE_DIALOG, CustomMessageDialog);
#line 38 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->vbox_main);
#line 39 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->lbl_msg);
#line 40 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->sw_msg);
#line 41 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->btn_ok);
#line 42 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->btn_cancel);
#line 43 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->btn_yes);
#line 44 "Utility/Gtk/CustomMessageDialog.vala"
	_g_object_unref0 (self->priv->btn_no);
#line 46 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (self->priv->msg_title);
#line 47 "Utility/Gtk/CustomMessageDialog.vala"
	_g_free0 (self->priv->msg_body);
#line 36 "Utility/Gtk/CustomMessageDialog.vala"
	G_OBJECT_CLASS (custom_message_dialog_parent_class)->finalize (obj);
#line 649 "CustomMessageDialog.c"
}

static GType
custom_message_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (CustomMessageDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) custom_message_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CustomMessageDialog), 0, (GInstanceInitFunc) custom_message_dialog_instance_init, NULL };
	GType custom_message_dialog_type_id;
	custom_message_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "CustomMessageDialog", &g_define_type_info, 0);
	CustomMessageDialog_private_offset = g_type_add_instance_private (custom_message_dialog_type_id, sizeof (CustomMessageDialogPrivate));
	return custom_message_dialog_type_id;
}

GType
custom_message_dialog_get_type (void)
{
	static volatile gsize custom_message_dialog_type_id__once = 0;
	if (g_once_init_enter (&custom_message_dialog_type_id__once)) {
		GType custom_message_dialog_type_id;
		custom_message_dialog_type_id = custom_message_dialog_get_type_once ();
		g_once_init_leave (&custom_message_dialog_type_id__once, custom_message_dialog_type_id);
	}
	return custom_message_dialog_type_id__once;
}

