/* IconManager.c generated by valac 0.56.3, the Vala compiler
 * generated from IconManager.vala, do not modify */

/*
 * IconManager.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gee.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <cairo-gobject.h>
#include <gdk/gdk.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>

#define ICON_MANAGER_SHIELD_ICON_SIZE 64
#define ICON_MANAGER_GENERIC_ICON_IMAGE "image-x-generic"
#define ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING "image-missing"
#define ICON_MANAGER_GENERIC_ICON_VIDEO "video-x-generic"
#define ICON_MANAGER_GENERIC_ICON_FILE "text-x-preview"
#define ICON_MANAGER_GENERIC_ICON_ARCHIVE_FILE "package-x-generic"
#define ICON_MANAGER_GENERIC_ICON_DIRECTORY "folder"
#define ICON_MANAGER_GENERIC_ICON_ISO "media-cdrom"
#define ICON_MANAGER_GENERIC_ICON_PDF "application-pdf"
#define ICON_MANAGER_ICON_HARDDRIVE "drive-harddisk"
#define ICON_MANAGER_SHIELD_LIVE "media-optical"
#define ICON_MANAGER_SHIELD_LOW "timeshift-shield-low"
#define ICON_MANAGER_SHIELD_MED "timeshift-shield-med"
#define ICON_MANAGER_SHIELD_HIGH "timeshift-shield-high"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ICON_MANAGER (icon_manager_get_type ())
#define ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ICON_MANAGER, IconManager))
#define ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ICON_MANAGER, IconManagerClass))
#define IS_ICON_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ICON_MANAGER))
#define IS_ICON_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ICON_MANAGER))
#define ICON_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ICON_MANAGER, IconManagerClass))

typedef struct _IconManager IconManager;
typedef struct _IconManagerClass IconManagerClass;
typedef struct _IconManagerPrivate IconManagerPrivate;
enum  {
	ICON_MANAGER_0_PROPERTY,
	ICON_MANAGER_NUM_PROPERTIES
};
static GParamSpec* icon_manager_properties[ICON_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _IconManager {
	GObject parent_instance;
	IconManagerPrivate * priv;
};

struct _IconManagerClass {
	GObjectClass parent_class;
};

static gpointer icon_manager_parent_class = NULL;
VALA_EXTERN GtkIconTheme* icon_manager_theme;
GtkIconTheme* icon_manager_theme = NULL;
VALA_EXTERN GeeArrayList* icon_manager_search_paths;
GeeArrayList* icon_manager_search_paths = NULL;
VALA_EXTERN gboolean GTK_INITIALIZED;

VALA_EXTERN GType icon_manager_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (IconManager, g_object_unref)
VALA_EXTERN void icon_manager_init (gchar** args,
                        gint args_length1,
                        const gchar* app_name);
VALA_EXTERN void tee_jee_logging_log_debug (const gchar* message);
VALA_EXTERN gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
VALA_EXTERN void icon_manager_refresh_icon_theme (void);
VALA_EXTERN GdkPixbuf* icon_manager_lookup (const gchar* icon_name,
                                gint icon_size,
                                gboolean symbolic,
                                gboolean use_hardcoded,
                                gint scale);
VALA_EXTERN gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
VALA_EXTERN gboolean tee_jee_file_system_file_exists (const gchar* file_path);
VALA_EXTERN GdkPixbuf* icon_manager_load_pixbuf_from_file (const gchar* file_path,
                                               gint icon_size);
VALA_EXTERN GtkImage* icon_manager_lookup_image (const gchar* icon_name,
                                     gint icon_size,
                                     gboolean symbolic,
                                     gboolean use_hardcoded);
VALA_EXTERN cairo_surface_t* icon_manager_lookup_surface (const gchar* icon_name,
                                              gint icon_size,
                                              gint scale,
                                              gboolean symbolic,
                                              gboolean use_hardcoded);
VALA_EXTERN GdkPixbuf* icon_manager_lookup_gicon (GIcon* gicon,
                                      gint icon_size);
VALA_EXTERN GdkPixbuf* icon_manager_add_emblem (GdkPixbuf* pixbuf,
                                    const gchar* icon_name,
                                    gint emblem_size,
                                    gboolean emblem_symbolic,
                                    GtkCornerType corner_type);
VALA_EXTERN void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
VALA_EXTERN GdkPixbuf* icon_manager_add_overlay (GdkPixbuf* pixbuf_base,
                                     GdkPixbuf* pixbuf_overlay);
VALA_EXTERN GdkPixbuf* icon_manager_resize_icon (GdkPixbuf* pixbuf_image,
                                     gint icon_size);
VALA_EXTERN GdkPixbuf* icon_manager_add_transparency (GdkPixbuf* pixbuf,
                                          gint opacity);
VALA_EXTERN IconManager* icon_manager_new (void);
VALA_EXTERN IconManager* icon_manager_construct (GType object_type);
static void icon_manager_finalize (GObject * obj);
static GType icon_manager_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

void
icon_manager_init (gchar** args,
                   gint args_length1,
                   const gchar* app_name)
{
	GeeArrayList* _tmp0_;
	gchar* path = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 61 "Utility/IconManager.vala"
	g_return_if_fail (app_name != NULL);
#line 63 "Utility/IconManager.vala"
	tee_jee_logging_log_debug ("IconManager: init()");
#line 65 "Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 65 "Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_search_paths);
#line 65 "Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 68 "Utility/IconManager.vala"
	_tmp1_ = g_strdup_printf ("/usr/share/%s/images", app_name);
#line 68 "Utility/IconManager.vala"
	path = _tmp1_;
#line 69 "Utility/IconManager.vala"
	_tmp2_ = path;
#line 69 "Utility/IconManager.vala"
	if (tee_jee_file_system_dir_exists (_tmp2_)) {
#line 182 "IconManager.c"
		GeeArrayList* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 70 "Utility/IconManager.vala"
		_tmp3_ = icon_manager_search_paths;
#line 70 "Utility/IconManager.vala"
		_tmp4_ = path;
#line 70 "Utility/IconManager.vala"
		gee_abstract_collection_add ((GeeAbstractCollection*) _tmp3_, _tmp4_);
#line 71 "Utility/IconManager.vala"
		_tmp5_ = path;
#line 71 "Utility/IconManager.vala"
		_tmp6_ = g_strdup_printf ("found images directory: %s", _tmp5_);
#line 71 "Utility/IconManager.vala"
		_tmp7_ = _tmp6_;
#line 71 "Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp7_);
#line 71 "Utility/IconManager.vala"
		_g_free0 (_tmp7_);
#line 204 "IconManager.c"
	}
#line 74 "Utility/IconManager.vala"
	icon_manager_refresh_icon_theme ();
#line 61 "Utility/IconManager.vala"
	_g_free0 (path);
#line 210 "IconManager.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 81 "Utility/IconManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 218 "IconManager.c"
}

void
icon_manager_refresh_icon_theme (void)
{
	GtkIconTheme* _tmp0_;
	GtkIconTheme* _tmp1_;
#line 79 "Utility/IconManager.vala"
	if (!GTK_INITIALIZED) {
#line 79 "Utility/IconManager.vala"
		return;
#line 230 "IconManager.c"
	}
#line 81 "Utility/IconManager.vala"
	_tmp0_ = gtk_icon_theme_get_default ();
#line 81 "Utility/IconManager.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 81 "Utility/IconManager.vala"
	_g_object_unref0 (icon_manager_theme);
#line 81 "Utility/IconManager.vala"
	icon_manager_theme = _tmp1_;
#line 240 "IconManager.c"
	{
		GeeArrayList* _path_list = NULL;
		GeeArrayList* _tmp2_;
		gint _path_size = 0;
		GeeArrayList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _path_index = 0;
#line 82 "Utility/IconManager.vala"
		_tmp2_ = icon_manager_search_paths;
#line 82 "Utility/IconManager.vala"
		_path_list = _tmp2_;
#line 82 "Utility/IconManager.vala"
		_tmp3_ = _path_list;
#line 82 "Utility/IconManager.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 82 "Utility/IconManager.vala"
		_tmp5_ = _tmp4_;
#line 82 "Utility/IconManager.vala"
		_path_size = _tmp5_;
#line 82 "Utility/IconManager.vala"
		_path_index = -1;
#line 82 "Utility/IconManager.vala"
		while (TRUE) {
#line 265 "IconManager.c"
			gint _tmp6_;
			gint _tmp7_;
			gchar* path = NULL;
			GeeArrayList* _tmp8_;
			gpointer _tmp9_;
			GtkIconTheme* _tmp10_;
			const gchar* _tmp11_;
#line 82 "Utility/IconManager.vala"
			_path_index = _path_index + 1;
#line 82 "Utility/IconManager.vala"
			_tmp6_ = _path_index;
#line 82 "Utility/IconManager.vala"
			_tmp7_ = _path_size;
#line 82 "Utility/IconManager.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 82 "Utility/IconManager.vala"
				break;
#line 283 "IconManager.c"
			}
#line 82 "Utility/IconManager.vala"
			_tmp8_ = _path_list;
#line 82 "Utility/IconManager.vala"
			_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _path_index);
#line 82 "Utility/IconManager.vala"
			path = (gchar*) _tmp9_;
#line 83 "Utility/IconManager.vala"
			_tmp10_ = icon_manager_theme;
#line 83 "Utility/IconManager.vala"
			_tmp11_ = path;
#line 83 "Utility/IconManager.vala"
			gtk_icon_theme_append_search_path (_tmp10_, _tmp11_);
#line 82 "Utility/IconManager.vala"
			_g_free0 (path);
#line 299 "IconManager.c"
		}
	}
}

GdkPixbuf*
icon_manager_lookup (const gchar* icon_name,
                     gint icon_size,
                     gboolean symbolic,
                     gboolean use_hardcoded,
                     gint scale)
{
	GdkPixbuf* pixbuf = NULL;
	gint _tmp0_;
	gint _tmp1_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 87 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 89 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 91 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 91 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 91 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 91 "Utility/IconManager.vala"
		result = NULL;
#line 91 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 91 "Utility/IconManager.vala"
		return result;
#line 332 "IconManager.c"
	}
#line 93 "Utility/IconManager.vala"
	if (!use_hardcoded) {
#line 336 "IconManager.c"
		{
			GdkPixbuf* _tmp2_ = NULL;
			GtkIconTheme* _tmp3_;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 95 "Utility/IconManager.vala"
			_tmp3_ = icon_manager_theme;
#line 95 "Utility/IconManager.vala"
			_tmp4_ = gtk_icon_theme_load_icon_for_scale (_tmp3_, icon_name, icon_size, scale, GTK_ICON_LOOKUP_FORCE_SIZE, &_inner_error0_);
#line 95 "Utility/IconManager.vala"
			_tmp2_ = _tmp4_;
#line 95 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 351 "IconManager.c"
				goto __catch0_g_error;
			}
#line 95 "Utility/IconManager.vala"
			_tmp5_ = _tmp2_;
#line 95 "Utility/IconManager.vala"
			_tmp2_ = NULL;
#line 95 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 95 "Utility/IconManager.vala"
			pixbuf = _tmp5_;
#line 96 "Utility/IconManager.vala"
			_tmp6_ = pixbuf;
#line 96 "Utility/IconManager.vala"
			if (_tmp6_ != NULL) {
#line 96 "Utility/IconManager.vala"
				result = pixbuf;
#line 96 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp2_);
#line 96 "Utility/IconManager.vala"
				return result;
#line 372 "IconManager.c"
			}
#line 94 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp2_);
#line 376 "IconManager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp7_;
			const gchar* _tmp8_;
#line 94 "Utility/IconManager.vala"
			e = _inner_error0_;
#line 94 "Utility/IconManager.vala"
			_inner_error0_ = NULL;
#line 99 "Utility/IconManager.vala"
			_tmp7_ = e;
#line 99 "Utility/IconManager.vala"
			_tmp8_ = _tmp7_->message;
#line 99 "Utility/IconManager.vala"
			tee_jee_logging_log_debug (_tmp8_);
#line 94 "Utility/IconManager.vala"
			_g_error_free0 (e);
#line 396 "IconManager.c"
		}
		__finally0:
#line 94 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 94 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 94 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 94 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 94 "Utility/IconManager.vala"
			return NULL;
#line 409 "IconManager.c"
		}
	}
	{
		GeeArrayList* _search_path_list = NULL;
		GeeArrayList* _tmp9_;
		gint _search_path_size = 0;
		GeeArrayList* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _search_path_index = 0;
#line 103 "Utility/IconManager.vala"
		_tmp9_ = icon_manager_search_paths;
#line 103 "Utility/IconManager.vala"
		_search_path_list = _tmp9_;
#line 103 "Utility/IconManager.vala"
		_tmp10_ = _search_path_list;
#line 103 "Utility/IconManager.vala"
		_tmp11_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp10_);
#line 103 "Utility/IconManager.vala"
		_tmp12_ = _tmp11_;
#line 103 "Utility/IconManager.vala"
		_search_path_size = _tmp12_;
#line 103 "Utility/IconManager.vala"
		_search_path_index = -1;
#line 103 "Utility/IconManager.vala"
		while (TRUE) {
#line 436 "IconManager.c"
			gint _tmp13_;
			gint _tmp14_;
			gchar* search_path = NULL;
			GeeArrayList* _tmp15_;
			gpointer _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
			gchar* _tmp20_;
			gchar** _tmp21_;
#line 103 "Utility/IconManager.vala"
			_search_path_index = _search_path_index + 1;
#line 103 "Utility/IconManager.vala"
			_tmp13_ = _search_path_index;
#line 103 "Utility/IconManager.vala"
			_tmp14_ = _search_path_size;
#line 103 "Utility/IconManager.vala"
			if (!(_tmp13_ < _tmp14_)) {
#line 103 "Utility/IconManager.vala"
				break;
#line 457 "IconManager.c"
			}
#line 103 "Utility/IconManager.vala"
			_tmp15_ = _search_path_list;
#line 103 "Utility/IconManager.vala"
			_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp15_, _search_path_index);
#line 103 "Utility/IconManager.vala"
			search_path = (gchar*) _tmp16_;
#line 105 "Utility/IconManager.vala"
			_tmp17_ = g_strdup (".svg");
#line 105 "Utility/IconManager.vala"
			_tmp18_ = g_strdup (".png");
#line 105 "Utility/IconManager.vala"
			_tmp19_ = g_strdup (".jpg");
#line 105 "Utility/IconManager.vala"
			_tmp20_ = g_strdup (".gif");
#line 105 "Utility/IconManager.vala"
			_tmp21_ = g_new0 (gchar*, 4 + 1);
#line 105 "Utility/IconManager.vala"
			_tmp21_[0] = _tmp17_;
#line 105 "Utility/IconManager.vala"
			_tmp21_[1] = _tmp18_;
#line 105 "Utility/IconManager.vala"
			_tmp21_[2] = _tmp19_;
#line 105 "Utility/IconManager.vala"
			_tmp21_[3] = _tmp20_;
#line 483 "IconManager.c"
			{
				gchar** ext_collection = NULL;
				gint ext_collection_length1 = 0;
				gint _ext_collection_size_ = 0;
				gint ext_it = 0;
#line 105 "Utility/IconManager.vala"
				ext_collection = _tmp21_;
#line 105 "Utility/IconManager.vala"
				ext_collection_length1 = 4;
#line 105 "Utility/IconManager.vala"
				for (ext_it = 0; ext_it < ext_collection_length1; ext_it = ext_it + 1) {
#line 495 "IconManager.c"
					gchar* _tmp22_;
					gchar* ext = NULL;
#line 105 "Utility/IconManager.vala"
					_tmp22_ = g_strdup (ext_collection[ext_it]);
#line 105 "Utility/IconManager.vala"
					ext = _tmp22_;
#line 502 "IconManager.c"
					{
						gchar* img_file = NULL;
						const gchar* _tmp23_;
						const gchar* _tmp24_;
						gchar* _tmp25_;
						gchar* _tmp26_;
						gchar* _tmp27_;
						gchar* _tmp28_;
						const gchar* _tmp29_;
#line 107 "Utility/IconManager.vala"
						_tmp23_ = search_path;
#line 107 "Utility/IconManager.vala"
						_tmp24_ = ext;
#line 107 "Utility/IconManager.vala"
						_tmp25_ = g_strconcat (icon_name, _tmp24_, NULL);
#line 107 "Utility/IconManager.vala"
						_tmp26_ = _tmp25_;
#line 107 "Utility/IconManager.vala"
						_tmp27_ = tee_jee_file_system_path_combine (_tmp23_, _tmp26_);
#line 107 "Utility/IconManager.vala"
						_tmp28_ = _tmp27_;
#line 107 "Utility/IconManager.vala"
						_g_free0 (_tmp26_);
#line 107 "Utility/IconManager.vala"
						img_file = _tmp28_;
#line 109 "Utility/IconManager.vala"
						_tmp29_ = img_file;
#line 109 "Utility/IconManager.vala"
						if (tee_jee_file_system_file_exists (_tmp29_)) {
#line 532 "IconManager.c"
							const gchar* _tmp30_;
							GdkPixbuf* _tmp31_;
							GdkPixbuf* _tmp32_;
#line 111 "Utility/IconManager.vala"
							_tmp30_ = img_file;
#line 111 "Utility/IconManager.vala"
							_tmp31_ = icon_manager_load_pixbuf_from_file (_tmp30_, icon_size);
#line 111 "Utility/IconManager.vala"
							_g_object_unref0 (pixbuf);
#line 111 "Utility/IconManager.vala"
							pixbuf = _tmp31_;
#line 112 "Utility/IconManager.vala"
							_tmp32_ = pixbuf;
#line 112 "Utility/IconManager.vala"
							if (_tmp32_ != NULL) {
#line 112 "Utility/IconManager.vala"
								result = pixbuf;
#line 112 "Utility/IconManager.vala"
								_g_free0 (img_file);
#line 112 "Utility/IconManager.vala"
								_g_free0 (ext);
#line 112 "Utility/IconManager.vala"
								ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 112 "Utility/IconManager.vala"
								_g_free0 (search_path);
#line 112 "Utility/IconManager.vala"
								return result;
#line 560 "IconManager.c"
							}
						}
#line 105 "Utility/IconManager.vala"
						_g_free0 (img_file);
#line 105 "Utility/IconManager.vala"
						_g_free0 (ext);
#line 567 "IconManager.c"
					}
				}
#line 105 "Utility/IconManager.vala"
				ext_collection = (_vala_array_free (ext_collection, ext_collection_length1, (GDestroyNotify) g_free), NULL);
#line 572 "IconManager.c"
			}
#line 103 "Utility/IconManager.vala"
			_g_free0 (search_path);
#line 576 "IconManager.c"
		}
	}
#line 117 "Utility/IconManager.vala"
	result = pixbuf;
#line 117 "Utility/IconManager.vala"
	return result;
#line 583 "IconManager.c"
}

GtkImage*
icon_manager_lookup_image (const gchar* icon_name,
                           gint icon_size,
                           gboolean symbolic,
                           gboolean use_hardcoded)
{
	gint _tmp0_;
	gint _tmp1_;
	GtkImage* image = NULL;
	GtkImage* _tmp2_;
	GdkPixbuf* pix = NULL;
	GtkImage* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	GdkPixbuf* _tmp7_;
	cairo_surface_t* surf = NULL;
	GdkPixbuf* _tmp12_;
	GtkImage* _tmp13_;
	gint _tmp14_;
	gint _tmp15_;
	cairo_surface_t* _tmp16_;
	GtkImage* _tmp17_;
	cairo_surface_t* _tmp18_;
	GtkImage* result;
#line 120 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 122 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 122 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 122 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 122 "Utility/IconManager.vala"
		result = NULL;
#line 122 "Utility/IconManager.vala"
		return result;
#line 623 "IconManager.c"
	}
#line 124 "Utility/IconManager.vala"
	_tmp2_ = (GtkImage*) gtk_image_new ();
#line 124 "Utility/IconManager.vala"
	g_object_ref_sink (_tmp2_);
#line 124 "Utility/IconManager.vala"
	image = _tmp2_;
#line 126 "Utility/IconManager.vala"
	_tmp3_ = image;
#line 126 "Utility/IconManager.vala"
	_tmp4_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp3_);
#line 126 "Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 126 "Utility/IconManager.vala"
	_tmp6_ = icon_manager_lookup (icon_name, icon_size, symbolic, use_hardcoded, _tmp5_);
#line 126 "Utility/IconManager.vala"
	pix = _tmp6_;
#line 128 "Utility/IconManager.vala"
	_tmp7_ = pix;
#line 128 "Utility/IconManager.vala"
	if (_tmp7_ == NULL) {
#line 645 "IconManager.c"
		GtkImage* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		GdkPixbuf* _tmp11_;
#line 129 "Utility/IconManager.vala"
		_tmp8_ = image;
#line 129 "Utility/IconManager.vala"
		_tmp9_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp8_);
#line 129 "Utility/IconManager.vala"
		_tmp10_ = _tmp9_;
#line 129 "Utility/IconManager.vala"
		_tmp11_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, icon_size, symbolic, use_hardcoded, _tmp10_);
#line 129 "Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 129 "Utility/IconManager.vala"
		pix = _tmp11_;
#line 662 "IconManager.c"
	}
#line 132 "Utility/IconManager.vala"
	_tmp12_ = pix;
#line 132 "Utility/IconManager.vala"
	_tmp13_ = image;
#line 132 "Utility/IconManager.vala"
	_tmp14_ = gtk_widget_get_scale_factor ((GtkWidget*) _tmp13_);
#line 132 "Utility/IconManager.vala"
	_tmp15_ = _tmp14_;
#line 132 "Utility/IconManager.vala"
	_tmp16_ = gdk_cairo_surface_create_from_pixbuf (_tmp12_, _tmp15_, NULL);
#line 132 "Utility/IconManager.vala"
	surf = _tmp16_;
#line 134 "Utility/IconManager.vala"
	_tmp17_ = image;
#line 134 "Utility/IconManager.vala"
	_tmp18_ = surf;
#line 134 "Utility/IconManager.vala"
	gtk_image_set_from_surface (_tmp17_, _tmp18_);
#line 136 "Utility/IconManager.vala"
	result = image;
#line 136 "Utility/IconManager.vala"
	_cairo_surface_destroy0 (surf);
#line 136 "Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 136 "Utility/IconManager.vala"
	return result;
#line 690 "IconManager.c"
}

cairo_surface_t*
icon_manager_lookup_surface (const gchar* icon_name,
                             gint icon_size,
                             gint scale,
                             gboolean symbolic,
                             gboolean use_hardcoded)
{
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* pix = NULL;
	GdkPixbuf* _tmp2_;
	GdkPixbuf* _tmp3_;
	GdkPixbuf* _tmp5_;
	cairo_surface_t* _tmp6_;
	cairo_surface_t* result;
#line 139 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 140 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 140 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 140 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 140 "Utility/IconManager.vala"
		result = NULL;
#line 140 "Utility/IconManager.vala"
		return result;
#line 720 "IconManager.c"
	}
#line 142 "Utility/IconManager.vala"
	_tmp2_ = icon_manager_lookup (icon_name, icon_size, symbolic, use_hardcoded, scale);
#line 142 "Utility/IconManager.vala"
	pix = _tmp2_;
#line 144 "Utility/IconManager.vala"
	_tmp3_ = pix;
#line 144 "Utility/IconManager.vala"
	if (_tmp3_ == NULL) {
#line 730 "IconManager.c"
		GdkPixbuf* _tmp4_;
#line 145 "Utility/IconManager.vala"
		_tmp4_ = icon_manager_lookup (ICON_MANAGER_GENERIC_ICON_IMAGE_MISSING, icon_size, symbolic, use_hardcoded, scale);
#line 145 "Utility/IconManager.vala"
		_g_object_unref0 (pix);
#line 145 "Utility/IconManager.vala"
		pix = _tmp4_;
#line 738 "IconManager.c"
	}
#line 148 "Utility/IconManager.vala"
	_tmp5_ = pix;
#line 148 "Utility/IconManager.vala"
	_tmp6_ = gdk_cairo_surface_create_from_pixbuf (_tmp5_, scale, NULL);
#line 148 "Utility/IconManager.vala"
	result = _tmp6_;
#line 148 "Utility/IconManager.vala"
	_g_object_unref0 (pix);
#line 148 "Utility/IconManager.vala"
	return result;
#line 750 "IconManager.c"
}

GdkPixbuf*
icon_manager_lookup_gicon (GIcon* gicon,
                           gint icon_size)
{
	GdkPixbuf* pixbuf = NULL;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 153 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 155 "Utility/IconManager.vala"
	if (gicon == NULL) {
#line 155 "Utility/IconManager.vala"
		result = NULL;
#line 155 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 155 "Utility/IconManager.vala"
		return result;
#line 770 "IconManager.c"
	}
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp0_;
		GtkIconInfo* _tmp1_;
		GtkIconInfo* _tmp2_;
#line 158 "Utility/IconManager.vala"
		_tmp0_ = icon_manager_theme;
#line 158 "Utility/IconManager.vala"
		_tmp1_ = gtk_icon_theme_lookup_by_gicon (_tmp0_, gicon, icon_size, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 158 "Utility/IconManager.vala"
		icon_info = _tmp1_;
#line 159 "Utility/IconManager.vala"
		_tmp2_ = icon_info;
#line 159 "Utility/IconManager.vala"
		if (_tmp2_ != NULL) {
#line 787 "IconManager.c"
			GdkPixbuf* _tmp3_ = NULL;
			GtkIconInfo* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
#line 160 "Utility/IconManager.vala"
			_tmp4_ = icon_info;
#line 160 "Utility/IconManager.vala"
			_tmp5_ = gtk_icon_info_load_icon (_tmp4_, &_inner_error0_);
#line 160 "Utility/IconManager.vala"
			_tmp3_ = _tmp5_;
#line 160 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 160 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 802 "IconManager.c"
				goto __catch0_g_error;
			}
#line 160 "Utility/IconManager.vala"
			_tmp6_ = _tmp3_;
#line 160 "Utility/IconManager.vala"
			_tmp3_ = NULL;
#line 160 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 160 "Utility/IconManager.vala"
			pixbuf = _tmp6_;
#line 159 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp3_);
#line 815 "IconManager.c"
		}
#line 157 "Utility/IconManager.vala"
		_g_object_unref0 (icon_info);
#line 819 "IconManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
#line 157 "Utility/IconManager.vala"
		e = _inner_error0_;
#line 157 "Utility/IconManager.vala"
		_inner_error0_ = NULL;
#line 164 "Utility/IconManager.vala"
		_tmp7_ = e;
#line 164 "Utility/IconManager.vala"
		_tmp8_ = _tmp7_->message;
#line 164 "Utility/IconManager.vala"
		tee_jee_logging_log_debug (_tmp8_);
#line 157 "Utility/IconManager.vala"
		_g_error_free0 (e);
#line 839 "IconManager.c"
	}
	__finally0:
#line 157 "Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 157 "Utility/IconManager.vala"
		_g_object_unref0 (pixbuf);
#line 157 "Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 157 "Utility/IconManager.vala"
		g_clear_error (&_inner_error0_);
#line 157 "Utility/IconManager.vala"
		return NULL;
#line 852 "IconManager.c"
	}
#line 167 "Utility/IconManager.vala"
	result = pixbuf;
#line 167 "Utility/IconManager.vala"
	return result;
#line 858 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_emblem (GdkPixbuf* pixbuf,
                         const gchar* icon_name,
                         gint emblem_size,
                         gboolean emblem_symbolic,
                         GtkCornerType corner_type)
{
	gint _tmp0_;
	gint _tmp1_;
	GdkPixbuf* emblem = NULL;
	GdkRGBA SMALL_EMBLEM_COLOR = {0};
	gint EMBLEM_PADDING = 0;
	GdkPixbuf* _tmp19_;
	gint offset_x = 0;
	gboolean _tmp21_ = FALSE;
	gint offset_y = 0;
	gboolean _tmp27_ = FALSE;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp33_;
	GdkPixbuf* _tmp34_;
	GdkPixbuf* _tmp35_;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 170 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 170 "Utility/IconManager.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 172 "Utility/IconManager.vala"
	_tmp0_ = strlen (icon_name);
#line 172 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 172 "Utility/IconManager.vala"
	if (_tmp1_ == 0) {
#line 894 "IconManager.c"
		GdkPixbuf* _tmp2_;
#line 172 "Utility/IconManager.vala"
		_tmp2_ = _g_object_ref0 (pixbuf);
#line 172 "Utility/IconManager.vala"
		result = _tmp2_;
#line 172 "Utility/IconManager.vala"
		return result;
#line 902 "IconManager.c"
	}
#line 174 "Utility/IconManager.vala"
	emblem = NULL;
#line 176 "Utility/IconManager.vala"
	memset (&SMALL_EMBLEM_COLOR, 0, sizeof (GdkRGBA));
#line 177 "Utility/IconManager.vala"
	gdk_rgba_parse (&SMALL_EMBLEM_COLOR, "#000000");
#line 178 "Utility/IconManager.vala"
	SMALL_EMBLEM_COLOR.alpha = 1.0;
#line 180 "Utility/IconManager.vala"
	EMBLEM_PADDING = 1;
#line 914 "IconManager.c"
	{
		GtkIconInfo* icon_info = NULL;
		GtkIconTheme* _tmp3_;
		GtkIconInfo* _tmp4_;
#line 183 "Utility/IconManager.vala"
		_tmp3_ = icon_manager_theme;
#line 183 "Utility/IconManager.vala"
		_tmp4_ = gtk_icon_theme_lookup_icon (_tmp3_, icon_name, emblem_size, GTK_ICON_LOOKUP_FORCE_SIZE);
#line 183 "Utility/IconManager.vala"
		icon_info = _tmp4_;
#line 184 "Utility/IconManager.vala"
		if (emblem_symbolic) {
#line 927 "IconManager.c"
			GdkPixbuf* _tmp5_ = NULL;
			GtkIconInfo* _tmp6_;
			GdkRGBA _tmp7_;
			GdkPixbuf* _tmp8_;
			GdkPixbuf* _tmp9_;
#line 185 "Utility/IconManager.vala"
			_tmp6_ = icon_info;
#line 185 "Utility/IconManager.vala"
			_tmp7_ = SMALL_EMBLEM_COLOR;
#line 185 "Utility/IconManager.vala"
			_tmp8_ = gtk_icon_info_load_symbolic (_tmp6_, &_tmp7_, NULL, NULL, NULL, NULL, &_inner_error0_);
#line 185 "Utility/IconManager.vala"
			_tmp5_ = _tmp8_;
#line 185 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 945 "IconManager.c"
				goto __catch0_g_error;
			}
#line 185 "Utility/IconManager.vala"
			_tmp9_ = _tmp5_;
#line 185 "Utility/IconManager.vala"
			_tmp5_ = NULL;
#line 185 "Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 185 "Utility/IconManager.vala"
			emblem = _tmp9_;
#line 184 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp5_);
#line 958 "IconManager.c"
		} else {
			GdkPixbuf* _tmp10_ = NULL;
			GtkIconInfo* _tmp11_;
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
#line 188 "Utility/IconManager.vala"
			_tmp11_ = icon_info;
#line 188 "Utility/IconManager.vala"
			_tmp12_ = gtk_icon_info_load_icon (_tmp11_, &_inner_error0_);
#line 188 "Utility/IconManager.vala"
			_tmp10_ = _tmp12_;
#line 188 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 188 "Utility/IconManager.vala"
				_g_object_unref0 (icon_info);
#line 974 "IconManager.c"
				goto __catch0_g_error;
			}
#line 188 "Utility/IconManager.vala"
			_tmp13_ = _tmp10_;
#line 188 "Utility/IconManager.vala"
			_tmp10_ = NULL;
#line 188 "Utility/IconManager.vala"
			_g_object_unref0 (emblem);
#line 188 "Utility/IconManager.vala"
			emblem = _tmp13_;
#line 184 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp10_);
#line 987 "IconManager.c"
		}
#line 182 "Utility/IconManager.vala"
		_g_object_unref0 (icon_info);
#line 991 "IconManager.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp14_;
		const gchar* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		GdkPixbuf* _tmp18_;
#line 182 "Utility/IconManager.vala"
		e = _inner_error0_;
#line 182 "Utility/IconManager.vala"
		_inner_error0_ = NULL;
#line 191 "Utility/IconManager.vala"
		_tmp14_ = e;
#line 191 "Utility/IconManager.vala"
		_tmp15_ = _tmp14_->message;
#line 191 "Utility/IconManager.vala"
		_tmp16_ = g_strdup_printf ("get_icon_emblemed(): %s", _tmp15_);
#line 191 "Utility/IconManager.vala"
		_tmp17_ = _tmp16_;
#line 191 "Utility/IconManager.vala"
		tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 191 "Utility/IconManager.vala"
		_g_free0 (_tmp17_);
#line 192 "Utility/IconManager.vala"
		_tmp18_ = _g_object_ref0 (pixbuf);
#line 192 "Utility/IconManager.vala"
		result = _tmp18_;
#line 192 "Utility/IconManager.vala"
		_g_error_free0 (e);
#line 192 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 192 "Utility/IconManager.vala"
		return result;
#line 1028 "IconManager.c"
	}
	__finally0:
#line 182 "Utility/IconManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 182 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 182 "Utility/IconManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 182 "Utility/IconManager.vala"
		g_clear_error (&_inner_error0_);
#line 182 "Utility/IconManager.vala"
		return NULL;
#line 1041 "IconManager.c"
	}
#line 195 "Utility/IconManager.vala"
	_tmp19_ = emblem;
#line 195 "Utility/IconManager.vala"
	if (_tmp19_ == NULL) {
#line 1047 "IconManager.c"
		GdkPixbuf* _tmp20_;
#line 196 "Utility/IconManager.vala"
		_tmp20_ = _g_object_ref0 (pixbuf);
#line 196 "Utility/IconManager.vala"
		result = _tmp20_;
#line 196 "Utility/IconManager.vala"
		_g_object_unref0 (emblem);
#line 196 "Utility/IconManager.vala"
		return result;
#line 1057 "IconManager.c"
	}
#line 198 "Utility/IconManager.vala"
	offset_x = EMBLEM_PADDING;
#line 200 "Utility/IconManager.vala"
	if (corner_type == GTK_CORNER_BOTTOM_RIGHT) {
#line 200 "Utility/IconManager.vala"
		_tmp21_ = TRUE;
#line 1065 "IconManager.c"
	} else {
#line 200 "Utility/IconManager.vala"
		_tmp21_ = corner_type == GTK_CORNER_TOP_RIGHT;
#line 1069 "IconManager.c"
	}
#line 200 "Utility/IconManager.vala"
	if (_tmp21_) {
#line 1073 "IconManager.c"
		gint _tmp22_;
		gint _tmp23_;
		GdkPixbuf* _tmp24_;
		gint _tmp25_;
		gint _tmp26_;
#line 201 "Utility/IconManager.vala"
		_tmp22_ = gdk_pixbuf_get_width (pixbuf);
#line 201 "Utility/IconManager.vala"
		_tmp23_ = _tmp22_;
#line 201 "Utility/IconManager.vala"
		_tmp24_ = emblem;
#line 201 "Utility/IconManager.vala"
		_tmp25_ = gdk_pixbuf_get_width (_tmp24_);
#line 201 "Utility/IconManager.vala"
		_tmp26_ = _tmp25_;
#line 201 "Utility/IconManager.vala"
		offset_x = (_tmp23_ - _tmp26_) - EMBLEM_PADDING;
#line 1091 "IconManager.c"
	}
#line 204 "Utility/IconManager.vala"
	offset_y = EMBLEM_PADDING;
#line 206 "Utility/IconManager.vala"
	if (corner_type == GTK_CORNER_BOTTOM_LEFT) {
#line 206 "Utility/IconManager.vala"
		_tmp27_ = TRUE;
#line 1099 "IconManager.c"
	} else {
#line 206 "Utility/IconManager.vala"
		_tmp27_ = corner_type == GTK_CORNER_BOTTOM_RIGHT;
#line 1103 "IconManager.c"
	}
#line 206 "Utility/IconManager.vala"
	if (_tmp27_) {
#line 1107 "IconManager.c"
		gint _tmp28_;
		gint _tmp29_;
		GdkPixbuf* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
#line 207 "Utility/IconManager.vala"
		_tmp28_ = gdk_pixbuf_get_height (pixbuf);
#line 207 "Utility/IconManager.vala"
		_tmp29_ = _tmp28_;
#line 207 "Utility/IconManager.vala"
		_tmp30_ = emblem;
#line 207 "Utility/IconManager.vala"
		_tmp31_ = gdk_pixbuf_get_height (_tmp30_);
#line 207 "Utility/IconManager.vala"
		_tmp32_ = _tmp31_;
#line 207 "Utility/IconManager.vala"
		offset_y = (_tmp29_ - _tmp32_) - EMBLEM_PADDING;
#line 1125 "IconManager.c"
	}
#line 210 "Utility/IconManager.vala"
	_tmp33_ = gdk_pixbuf_copy (pixbuf);
#line 210 "Utility/IconManager.vala"
	emblemed = _tmp33_;
#line 212 "Utility/IconManager.vala"
	_tmp34_ = emblem;
#line 212 "Utility/IconManager.vala"
	_tmp35_ = emblemed;
#line 212 "Utility/IconManager.vala"
	gdk_pixbuf_composite (_tmp34_, _tmp35_, offset_x, offset_y, emblem_size, emblem_size, (gdouble) offset_x, (gdouble) offset_y, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 219 "Utility/IconManager.vala"
	result = emblemed;
#line 219 "Utility/IconManager.vala"
	_g_object_unref0 (emblem);
#line 219 "Utility/IconManager.vala"
	return result;
#line 1143 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_overlay (GdkPixbuf* pixbuf_base,
                          GdkPixbuf* pixbuf_overlay)
{
	gint offset_x = 0;
	gint _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint offset_y = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	GdkPixbuf* emblemed = NULL;
	GdkPixbuf* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	GdkPixbuf* result;
#line 222 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_base != NULL, NULL);
#line 222 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_overlay != NULL, NULL);
#line 224 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_get_width (pixbuf_base);
#line 224 "Utility/IconManager.vala"
	_tmp1_ = _tmp0_;
#line 224 "Utility/IconManager.vala"
	_tmp2_ = gdk_pixbuf_get_width (pixbuf_overlay);
#line 224 "Utility/IconManager.vala"
	_tmp3_ = _tmp2_;
#line 224 "Utility/IconManager.vala"
	offset_x = (_tmp1_ - _tmp3_) / 2;
#line 226 "Utility/IconManager.vala"
	_tmp4_ = gdk_pixbuf_get_height (pixbuf_base);
#line 226 "Utility/IconManager.vala"
	_tmp5_ = _tmp4_;
#line 226 "Utility/IconManager.vala"
	_tmp6_ = gdk_pixbuf_get_height (pixbuf_overlay);
#line 226 "Utility/IconManager.vala"
	_tmp7_ = _tmp6_;
#line 226 "Utility/IconManager.vala"
	offset_y = (_tmp5_ - _tmp7_) / 2;
#line 228 "Utility/IconManager.vala"
	_tmp8_ = gdk_pixbuf_copy (pixbuf_base);
#line 228 "Utility/IconManager.vala"
	emblemed = _tmp8_;
#line 230 "Utility/IconManager.vala"
	_tmp9_ = gdk_pixbuf_get_width (pixbuf_overlay);
#line 230 "Utility/IconManager.vala"
	_tmp10_ = _tmp9_;
#line 230 "Utility/IconManager.vala"
	_tmp11_ = gdk_pixbuf_get_height (pixbuf_overlay);
#line 230 "Utility/IconManager.vala"
	_tmp12_ = _tmp11_;
#line 230 "Utility/IconManager.vala"
	gdk_pixbuf_composite (pixbuf_overlay, emblemed, offset_x, offset_y, _tmp10_, _tmp12_, (gdouble) offset_x, (gdouble) offset_y, 1.0, 1.0, GDK_INTERP_BILINEAR, 255);
#line 237 "Utility/IconManager.vala"
	result = emblemed;
#line 237 "Utility/IconManager.vala"
	return result;
#line 1209 "IconManager.c"
}

GdkPixbuf*
icon_manager_resize_icon (GdkPixbuf* pixbuf_image,
                          gint icon_size)
{
	GdkPixbuf* pixbuf_empty = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* pixbuf_resized = NULL;
	GdkPixbuf* _tmp1_;
	GdkPixbuf* result;
#line 240 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf_image != NULL, NULL);
#line 244 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_new (GDK_COLORSPACE_RGB, TRUE, 8, icon_size, icon_size);
#line 244 "Utility/IconManager.vala"
	pixbuf_empty = _tmp0_;
#line 245 "Utility/IconManager.vala"
	gdk_pixbuf_fill (pixbuf_empty, (guint32) 0x00000000);
#line 249 "Utility/IconManager.vala"
	_tmp1_ = icon_manager_add_overlay (pixbuf_empty, pixbuf_image);
#line 249 "Utility/IconManager.vala"
	pixbuf_resized = _tmp1_;
#line 255 "Utility/IconManager.vala"
	result = pixbuf_resized;
#line 255 "Utility/IconManager.vala"
	_g_object_unref0 (pixbuf_empty);
#line 255 "Utility/IconManager.vala"
	return result;
#line 1239 "IconManager.c"
}

GdkPixbuf*
icon_manager_add_transparency (GdkPixbuf* pixbuf,
                               gint opacity)
{
	GdkPixbuf* trans = NULL;
	GdkPixbuf* _tmp0_;
	gint width = 0;
	gint height = 0;
	GdkPixbuf* result;
#line 258 "Utility/IconManager.vala"
	g_return_val_if_fail (pixbuf != NULL, NULL);
#line 260 "Utility/IconManager.vala"
	_tmp0_ = gdk_pixbuf_copy (pixbuf);
#line 260 "Utility/IconManager.vala"
	trans = _tmp0_;
#line 261 "Utility/IconManager.vala"
	gdk_pixbuf_fill (trans, (guint32) 0xFFFFFF00LL);
#line 265 "Utility/IconManager.vala"
	width = gdk_pixbuf_get_width (pixbuf);
#line 266 "Utility/IconManager.vala"
	height = gdk_pixbuf_get_height (pixbuf);
#line 267 "Utility/IconManager.vala"
	gdk_pixbuf_composite (pixbuf, trans, 0, 0, width, height, (gdouble) 0, (gdouble) 0, 1.0, 1.0, GDK_INTERP_BILINEAR, opacity);
#line 269 "Utility/IconManager.vala"
	result = trans;
#line 269 "Utility/IconManager.vala"
	return result;
#line 1269 "IconManager.c"
}

GdkPixbuf*
icon_manager_load_pixbuf_from_file (const gchar* file_path,
                                    gint icon_size)
{
	GdkPixbuf* pixbuf = NULL;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gboolean _tmp2_ = FALSE;
	GError* _inner_error0_ = NULL;
	GdkPixbuf* result;
#line 272 "Utility/IconManager.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 274 "Utility/IconManager.vala"
	pixbuf = NULL;
#line 277 "Utility/IconManager.vala"
	gdk_pixbuf_get_file_info (file_path, &_tmp0_, &_tmp1_);
#line 277 "Utility/IconManager.vala"
	width = _tmp0_;
#line 277 "Utility/IconManager.vala"
	height = _tmp1_;
#line 279 "Utility/IconManager.vala"
	if (width <= icon_size) {
#line 279 "Utility/IconManager.vala"
		_tmp2_ = height <= icon_size;
#line 1298 "IconManager.c"
	} else {
#line 279 "Utility/IconManager.vala"
		_tmp2_ = FALSE;
#line 1302 "IconManager.c"
	}
#line 279 "Utility/IconManager.vala"
	if (_tmp2_) {
#line 1306 "IconManager.c"
		{
			GdkPixbuf* _tmp3_ = NULL;
			GdkPixbuf* _tmp4_;
			GdkPixbuf* _tmp5_;
			GdkPixbuf* _tmp6_;
			GdkPixbuf* _tmp7_;
			GdkPixbuf* _tmp8_;
#line 282 "Utility/IconManager.vala"
			_tmp4_ = gdk_pixbuf_new_from_file (file_path, &_inner_error0_);
#line 282 "Utility/IconManager.vala"
			_tmp3_ = _tmp4_;
#line 282 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1320 "IconManager.c"
				goto __catch0_g_error;
			}
#line 282 "Utility/IconManager.vala"
			_tmp5_ = _tmp3_;
#line 282 "Utility/IconManager.vala"
			_tmp3_ = NULL;
#line 282 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 282 "Utility/IconManager.vala"
			pixbuf = _tmp5_;
#line 284 "Utility/IconManager.vala"
			_tmp6_ = pixbuf;
#line 284 "Utility/IconManager.vala"
			_tmp7_ = icon_manager_resize_icon (_tmp6_, icon_size);
#line 284 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 284 "Utility/IconManager.vala"
			pixbuf = _tmp7_;
#line 286 "Utility/IconManager.vala"
			_tmp8_ = pixbuf;
#line 286 "Utility/IconManager.vala"
			if (_tmp8_ != NULL) {
#line 286 "Utility/IconManager.vala"
				result = pixbuf;
#line 286 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp3_);
#line 286 "Utility/IconManager.vala"
				return result;
#line 1349 "IconManager.c"
			}
#line 280 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp3_);
#line 1353 "IconManager.c"
		}
		goto __finally0;
		__catch0_g_error:
		{
#line 280 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 1360 "IconManager.c"
		}
		__finally0:
#line 280 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 280 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 280 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 280 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 280 "Utility/IconManager.vala"
			return NULL;
#line 1373 "IconManager.c"
		}
	} else {
		{
			GdkPixbuf* _tmp9_ = NULL;
			GdkPixbuf* _tmp10_;
			GdkPixbuf* _tmp11_;
			GdkPixbuf* _tmp12_;
			GdkPixbuf* _tmp13_;
			GdkPixbuf* _tmp14_;
#line 295 "Utility/IconManager.vala"
			_tmp10_ = gdk_pixbuf_new_from_file_at_scale (file_path, icon_size, icon_size, TRUE, &_inner_error0_);
#line 295 "Utility/IconManager.vala"
			_tmp9_ = _tmp10_;
#line 295 "Utility/IconManager.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1389 "IconManager.c"
				goto __catch1_g_error;
			}
#line 295 "Utility/IconManager.vala"
			_tmp11_ = _tmp9_;
#line 295 "Utility/IconManager.vala"
			_tmp9_ = NULL;
#line 295 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 295 "Utility/IconManager.vala"
			pixbuf = _tmp11_;
#line 297 "Utility/IconManager.vala"
			_tmp12_ = pixbuf;
#line 297 "Utility/IconManager.vala"
			_tmp13_ = icon_manager_resize_icon (_tmp12_, icon_size);
#line 297 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 297 "Utility/IconManager.vala"
			pixbuf = _tmp13_;
#line 299 "Utility/IconManager.vala"
			_tmp14_ = pixbuf;
#line 299 "Utility/IconManager.vala"
			if (_tmp14_ != NULL) {
#line 299 "Utility/IconManager.vala"
				result = pixbuf;
#line 299 "Utility/IconManager.vala"
				_g_object_unref0 (_tmp9_);
#line 299 "Utility/IconManager.vala"
				return result;
#line 1418 "IconManager.c"
			}
#line 293 "Utility/IconManager.vala"
			_g_object_unref0 (_tmp9_);
#line 1422 "IconManager.c"
		}
		goto __finally1;
		__catch1_g_error:
		{
#line 293 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 1429 "IconManager.c"
		}
		__finally1:
#line 293 "Utility/IconManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 293 "Utility/IconManager.vala"
			_g_object_unref0 (pixbuf);
#line 293 "Utility/IconManager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 293 "Utility/IconManager.vala"
			g_clear_error (&_inner_error0_);
#line 293 "Utility/IconManager.vala"
			return NULL;
#line 1442 "IconManager.c"
		}
	}
#line 306 "Utility/IconManager.vala"
	result = NULL;
#line 306 "Utility/IconManager.vala"
	_g_object_unref0 (pixbuf);
#line 306 "Utility/IconManager.vala"
	return result;
#line 1451 "IconManager.c"
}

IconManager*
icon_manager_construct (GType object_type)
{
	IconManager * self = NULL;
#line 37 "Utility/IconManager.vala"
	self = (IconManager*) g_object_new (object_type, NULL);
#line 37 "Utility/IconManager.vala"
	return self;
#line 1462 "IconManager.c"
}

IconManager*
icon_manager_new (void)
{
#line 37 "Utility/IconManager.vala"
	return icon_manager_construct (TYPE_ICON_MANAGER);
#line 1470 "IconManager.c"
}

static void
icon_manager_class_init (IconManagerClass * klass,
                         gpointer klass_data)
{
	GeeArrayList* _tmp0_;
#line 37 "Utility/IconManager.vala"
	icon_manager_parent_class = g_type_class_peek_parent (klass);
#line 37 "Utility/IconManager.vala"
	G_OBJECT_CLASS (klass)->finalize = icon_manager_finalize;
#line 41 "Utility/IconManager.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 41 "Utility/IconManager.vala"
	icon_manager_search_paths = _tmp0_;
#line 1486 "IconManager.c"
}

static void
icon_manager_instance_init (IconManager * self,
                            gpointer klass)
{
}

static void
icon_manager_finalize (GObject * obj)
{
	IconManager * self;
#line 37 "Utility/IconManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ICON_MANAGER, IconManager);
#line 37 "Utility/IconManager.vala"
	G_OBJECT_CLASS (icon_manager_parent_class)->finalize (obj);
#line 1503 "IconManager.c"
}

static GType
icon_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (IconManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) icon_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (IconManager), 0, (GInstanceInitFunc) icon_manager_instance_init, NULL };
	GType icon_manager_type_id;
	icon_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "IconManager", &g_define_type_info, 0);
	return icon_manager_type_id;
}

GType
icon_manager_get_type (void)
{
	static volatile gsize icon_manager_type_id__once = 0;
	if (g_once_init_enter (&icon_manager_type_id__once)) {
		GType icon_manager_type_id;
		icon_manager_type_id = icon_manager_get_type_once ();
		g_once_init_leave (&icon_manager_type_id__once, icon_manager_type_id);
	}
	return icon_manager_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

